

declare global {
    interface LatLng {
        lat: number
        lng: number
    }
    interface geoloc {
        title: string
        osm_id: number
        latlon: [number, number]
        notes: string
        step: -1
    }

    interface map {
        zoom: number
        center: LatLng
    }


    interface leg {
        title: string
        day_title: string[]
        date_range: [Date, Date] | null
        map: map
        travel: geoloc[]
        hotel: geoloc | null
        places: {
            restaurants: geoloc[]
            activities: geoloc[]
        }
        notes: string
    }

    interface journey {
        fmt_ver: number
        title: string
        main: leg[]
    }
}

const leg_template: leg = {
    title: "",
    day_title: [],
    map: { zoom: 2, center: { lng: 0, lat: 0 } },
    travel: [],
    hotel: null,
    places: { restaurants: [], activities: [] },
    notes: "",
    date_range: null
}
const journey_template: journey = {
    fmt_ver: 1,
    title: "New Journey",
    main: [leg_template],
}


export { map, geoloc, leg, journey }
export { journey_template, leg_template }